#ifndef SEARCH_FOR_TYPEDEF_DECLARATION_H_INCLUDED_
#define SEARCH_FOR_TYPEDEF_DECLARATION_H_INCLUDED_

#include <string>
#include "rose.h"

namespace risc
{

namespace tools
{

/**
  * \brief                      This function searchs for a typedef's by name
  *                             (string) in namespace (string)
  * \param  class_name          Name of the class
  * \param  qualified_namespace The absolute qualified namespace
  * \param  root_node           In this subtree the search will performed
  * \return                     Pointer to the class definition. The pointer is
  *                             zero, if the class does not exist in the given
  *                             namespace
  */
SgTypedefDeclaration* find_typedef_declaration(std::string class_name,
  std::string qualified_namespace, SgNode* root_node);

} // end namespace tools

} // end namespace risc

#endif /* SEARCH_FOR_TYPEDEF_DECLARATION_H_INCLUDED_ */

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
