#include "systemc.h"

class Foo: public sc_module {
public:

  sc_event e1;
  sc_event e2;
  sc_event e3;

  int a, b, c;
  float f;
  double d;

  sc_in_clk c1;

  sc_in<int> in_port_int;
  sc_out<long> out_port_long;
  sc_inout<double> inout_port_double;

  sc_in<bool> reset1;
  sc_in<bool> reset2;

  SC_HAS_PROCESS(Foo);

  Foo(sc_module_name mn):
    sc_module(mn)
  {
    SC_THREAD(my_thread1);
    sensitive << e1 << e2 << e3;

    SC_CTHREAD(my_cthread1, c1.pos());
    reset_signal_is(reset1, false);

    SC_THREAD(my_thread2);
    sensitive << e1;
    sensitive << e3;

    SC_CTHREAD(my_cthread2, c1.neg());
    reset_signal_is(reset2, true);

    SC_METHOD(my_method1);
    sensitive << e1;

    SC_CTHREAD(my_cthread3, c1.pos());
    reset_signal_is(reset1, false);
    reset_signal_is(reset2, true);

    SC_CTHREAD(my_cthread4, c1.pos());

    SC_METHOD(my_method2);
  }

  void my_thread1()
  { }

  void my_thread2()
  { }

  void my_method1()
  { }

  void my_method2()
  { }

  void my_cthread1()
  { }

  void my_cthread2()
  { }

  void my_cthread3()
  { }

  void my_cthread4()
  { }

  void gloabl1()
  { }

  void gloabl2()
  { }
};

class Testbench: public sc_module {
public:

  Foo f;

  sc_clock clk;
  sc_signal<int> signal_i;
  sc_signal<long> signal_l;
  sc_signal<double> signal_d;
  sc_signal<bool> signal_b;

  Testbench(sc_module_name nm):
    sc_module(nm),
    f("f")
  {
    f.c1.bind(clk);
    f.in_port_int.bind(signal_i);
    f.out_port_long.bind(signal_l);
    f.inout_port_double.bind(signal_d);
    f.reset1.bind(signal_b);
    f.reset2.bind(signal_b);
  }
};


int sc_main(int argc, char* argv[])
{

  Testbench tb("tb");

  sc_start(100, SC_NS);


  return 0;
}

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
